module IOTest where

import System.IO
import Data.Bits
import Data.IORef
import GHC.IOBase
import Control.Concurrent

echo = getChar >>= putChar

echoDup = getChar >>= (\a -> putChar a >> putChar a >> putChar '\n')

forever a = a >> forever a

repeatN 0 a = return ()
repeatN (n+1) a = a >> (repeatN n a)

for [] _ = return ()
for (n:ns) fa = fa n >> (for ns fa)

nfor fa = sequence_ . (map fa)

nl = putChar '\n'

done:: IO ()
done = return ()

puts [] = done
puts (x:xs) = putChar x >> puts xs

putsln xs = puts xs >> nl

puts1 xs = sequence_ (map putChar xs)

puts2  = mapM putChar

putn n c = sequence_ (take n (repeat (putChar c)))


a = newIOArray (0,9) 10

putidx i a = a >>= \ar -> (readIOArray ar 0) >>= \x -> putsln (show x)

